﻿
Imports System.Runtime.InteropServices
Imports System.Text

Module Module_Watch_ArduinoIDE

    <DllImport("user32.dll", SetLastError:=True)> _
    Private Function GetForegroundWindow() As IntPtr
    End Function

    <DllImport("user32.dll", SetLastError:=True, CharSet:=CharSet.Auto)> _
    Private Function GetWindowTextLength(ByVal hWnd As IntPtr) As Integer
    End Function

    <DllImport("user32.dll", CharSet:=CharSet.Auto, SetLastError:=True)> _
    Private Function GetWindowText(ByVal hWnd As IntPtr, ByVal lpString As StringBuilder, ByVal nMaxCount As Integer) As Integer
    End Function

    Private Function GetActiveWindowTitle() As String
        Dim handle As IntPtr = GetForegroundWindow()
        Dim length As Integer = GetWindowTextLength(handle)
        Dim title As New StringBuilder("", length + 1)
        GetWindowText(handle, title, title.Capacity)
        Return title.ToString()
    End Function

    ' ----------------------------------------------------- about 50 uS 
    Private Function ArduinoIDE_HasFocus() As Boolean
        Dim s As String = GetActiveWindowTitle()
        'Return s.StartsWith("Theremino_Tester_Sketch") And s.Contains(" | Arduino")
        Return s.Contains(" | Arduino")
    End Function

    ' ==========================================================
    '  Call from Form1.Timer_100ms
    ' ==========================================================
    Friend Sub TestArduinoIDE()
        Static TryToReconnect As Boolean = False
        If ArduinoIDE_HasFocus() Then
            If InOutModules.Count > 0 Then
                ' -------------------------------------------------------- DISCONNECT IF ARDUINO IDE FOCUSED
                Form1.Cmd_DisconnectSelectedModule()
                Console.Beep(880, 50)
                Console.Beep(440, 50)
                TryToReconnect = True
            End If
        Else
            ' ------------------------------------------------------------ RECONNECT 
            If TryToReconnect Then
                TryToReconnect = False
                Console.Beep(440, 50)
                Console.Beep(880, 50)
                Form1.Cmd_Recognize()
            End If
        End If
    End Sub

End Module
