
Friend Class Form1
    Inherits System.Windows.Forms.Form

    Private m As Threading.Mutex = New Threading.Mutex(False, "ThereminoArduHelperMutex")
    Private Function AlreadyRunning() As Boolean
        If Not m.WaitOne(0, False) Then
            'MsgBox("ThereminoHelper is already running", MsgBoxStyle.Information)
            Return True
        End If
        Return False
    End Function

    Private Sub Form_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
        '
        If AlreadyRunning() Then End
        '
        EventsAreEnabled = False
        Load_INI()
        Me.Text = AppTitleAndVersion()
        EventsAreEnabled = True

        ' ----------------------------------------------------------------
        Refresh()
        Opacity = 1
        ' ----------------------------------------------------------------
        Label1.Text = vbCrLf + _
                      "This application improves the Arduino IDE versions 1.xxx" + vbCrLf + vbCrLf + _
                      "Use the green button to modify the Arduino IDE colors" + vbCrLf + vbCrLf

        Label1.Text += "The patched file is:" + vbCrLf + _
                      "  C:\Program Files (x86)\Arduino\lib\theme\theme.txt"

        ' ----------------------------------------------------------------
        DecodeCommandLine()
    End Sub

    Private Sub Form_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        CloseProgram()
    End Sub

    Private Sub CloseProgram()
        Save_INI()
        End
    End Sub

    Private Sub Form_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Exit Sub
        LimitFormPosition(Me)
    End Sub

    ' =================================================================================================================
    '  DECODE COMMAND LINE
    ' =================================================================================================================
    Private Sub DecodeCommandLine()
        Dim Arguments As String() = Environment.GetCommandLineArgs()
        If Arguments.Length > 1 Then
            ShowMainWindow()
            Select Case Arguments(1)
                Case "RestoreTheFile_ThemeTXT" : RestoreTheFile_ThemeTXT()
                Case "PatchTheFile_ThemeTXT" : PatchTheFile_ThemeTXT()
            End Select
        End If
    End Sub

    Private Sub ShowMainWindow()
        Opacity = 0
        Me.Show()
        WindowState = FormWindowState.Normal
        Me.Refresh()
        Me.Focus()
        Opacity = 1
    End Sub

    ' =================================================================================================================
    '  BUTTONS
    ' =================================================================================================================
    Private Sub btn_RestoreThemeTxt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_RestoreThemeTxt.Click
        RestoreTheFile_ThemeTXT()
    End Sub
    Private Sub btn_OpenThemeFolder_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_OpenThemeFolder.Click
        OpenTheFolderContainingTheFile_ThemeTXT()
    End Sub
    Private Sub btn_ChangeColors_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_ChangeColors.Click
        PatchTheFile_ThemeTXT()
    End Sub

End Class