﻿Module ArduinoColors

    ' ================================================================================================
    ' - ENGLISH - ArduinoIDE Change Colors
    ' ================================================================================================
    '  This script corrects the file: C:\Program Files (x86)\Arduino\lib\theme\theme.txt
    '  The messages colors are changed from an impossible dark-red on black,
    '  to normal and easely redable colors.
    ' ================================================================================================

    ' ================================================================================================
    ' - ITALIANO - ArduinoIDE Change Colors
    ' ================================================================================================
    '  Questo script corregge il file: C:\Program Files (x86)\Arduino\lib\theme\theme.txt
    '  I colori del messaggi vengono modificati da un assurdo rosso scuro su nero,
    '  a colori normali e facilmente leggibili.
    ' ================================================================================================

    ' ================================================================================================
    ' The "PatchTheFile_ThemeTXT" function opens the file: <arduino> \ Lib \ theme.theme.txt 
    ' and changes the colors in the section "GUI - CONSOLE".   
    ' ================================================================================================
    '# GUI - CONSOLE  (ORIGINAL COLORS)
    'console.font = Monospaced,plain,11
    'console.font.macosx = Monaco,plain,10
    'console.color = #000000
    'console.output.color = #eeeeee
    'console.Error.color = #E34C00
    ' ------------------------------------------------------------------------------------------------
    '# GUI - CONSOLE  (CHANGED COLORS)
    'console.font = Monospaced,plain,11
    'console.font.macosx = Monaco,plain,10
    'console.color = #FFFFFF
    'console.output.color = #000000
    'console.Error.color = #600000
    ' ================================================================================================

    Friend Sub OpenTheFolderContainingTheFile_ThemeTXT()
        If Not TestArduinoExePath() Then Return
        If IO.Directory.Exists(ThemeFilePath) Then
            Process.Start(ThemeFilePath)
        End If
    End Sub

    Friend Sub RestoreTheFile_ThemeTXT()
        If Not TestArduinoExePath() Then Return
        Dim file1 As String = ThemeFilePath + "theme.txt"
        Dim file2 As String = ThemeFilePath + "theme_backup.txt"
        If IO.File.Exists(file2) Then
            Try
                IO.File.Copy(file2, file1, True)
                Form1.Label1.Text = vbCrLf + ">>> SUCCESS <<<" + vbCrLf + "The ""theme.txt"" file has been restored from  ""theme_backup.txt"" file."
                Form1.Label1.BackColor = Color.FromArgb(210, 255, 210)
            Catch
                ' ----------------------------------------------------- if error then restart with admin privileges 
                RestartArguments = "RestoreTheFile_ThemeTXT"
                If Not EnsureAdminPrivileges() Then
                    Return
                End If
            End Try
        Else
            Form1.Label1.Text = "The ""theme_backup.txt"" file is not found."
            Form1.Label1.BackColor = Color.FromArgb(255, 240, 200)
        End If
    End Sub

    Friend Sub PatchTheFile_ThemeTXT()
        ' -------------------------------------------------------------
        If Not TestArduinoExePath() Then Return
        '
        ' ------------------------------------------------------------- create file path and test it
        Dim file1 As String = ThemeFilePath + "theme.txt"
        Dim file2 As String = ThemeFilePath + "theme_backup.txt"
        If IO.File.Exists(file1) Then
            Form1.Label1.Text = "The path is valid: " + vbCrLf + file1
        Else
            Form1.Label1.Text = "Path not found: " + vbCrLf + file1
            Form1.Label1.BackColor = Color.FromArgb(255, 240, 200)
            Return
        End If
        ' ------------------------------------------------------------- open and read file1	
        Dim sr As IO.StreamReader = New IO.StreamReader(file1)
        Dim s As String = sr.ReadToEnd
        sr.Close()
        ' ------------------------------------------------------------- test the string
        If s.Contains(vbLf + "console.color = #000000") Then
            ' --------------------------------------------------------- try if it is possible to copy the file
            '
            Try
                ' ----------------------------------------------------- make a backup copy
                My.Computer.FileSystem.CopyFile(file1, file2, True)
                Form1.Label1.Text += vbCrLf + vbCrLf
                Form1.Label1.Text += "The file has been copied for backup as:"
                Form1.Label1.Text += vbCrLf + file2
            Catch
                ' ----------------------------------------------------- if error then restart with admin privileges 
                RestartArguments = "PatchTheFile_ThemeTXT"
                If Not EnsureAdminPrivileges() Then
                    Return
                End If
            End Try
            '
            ' --------------------------------------------------------- replace the string
            s = s.Replace(vbLf + "console.color = #000000", _
                          vbLf + "console.color = #FFFFFF")   ' or FFFFD0

            s = s.Replace(vbLf + "console.output.color = #eeeeee", _
                          vbLf + "console.output.color = #000000")

            s = s.Replace(vbLf + "console.error.color = #E34C00", _
                          vbLf + "console.error.color = #E00000")
            ' --------------------------------------------------------- write file1
            Dim sw As IO.StreamWriter = New IO.StreamWriter(file1)
            sw.Write(s)
            sw.Close()
            ' --------------------------------------------------------- final message
            Form1.Label1.Text += vbCrLf + vbCrLf
            Form1.Label1.Text += ">>> SUCCESS <<<" + vbCrLf + "Arduino IDE colors are improved." + vbCrLf
            Form1.Label1.Text += "To see the new colors close and reopen the Arduino IDE."
            Form1.Label1.BackColor = Color.FromArgb(210, 255, 210)
        Else
            Form1.Label1.Text += vbCrLf + vbCrLf
            Form1.Label1.Text += "The line: ""console.color = #000000"" has not been found in the file." + vbCrLf
            Form1.Label1.Text += vbCrLf
            Form1.Label1.Text += "The colors have probably already been corrected."
            Form1.Label1.BackColor = Color.FromArgb(255, 240, 200)
        End If
    End Sub


    'Private Sub CopyFile(ByVal file1 As String, ByVal file2 As String)
    '    ' ---------------------------------------------------- read file1	
    '    Dim sr As IO.StreamReader = New IO.StreamReader(file1)
    '    Dim s As String = sr.ReadToEnd
    '    sr.Close()
    '    ' ---------------------------------------------------- write file2
    '    Dim sw As IO.StreamWriter = New IO.StreamWriter(file2)
    '    sw.Write(s)
    '    sw.Close()
    'End Sub

End Module
