﻿Module Module_RestartAsAdministrator

    Friend Function EnsureAdminPrivileges() As Boolean
        If Not IsAdministrator() Then
            If Not CallUserPermission() Then
                Message_NoSupervisor()
                Return False
            End If
        End If
        Return True
    End Function

    Private Sub Message_NoSupervisor()
        Form1.Label1.Text = vbCrLf + vbCrLf
        Form1.Label1.Text += "The user has not agreed to grant supervisor privileges." + vbCrLf
        Form1.Label1.Text += vbCrLf
        Form1.Label1.Text += "Nothing was done."
        Form1.Label1.BackColor = Color.FromArgb(255, 240, 200)
        '
        MessageBox.Show("The user has not agreed to grant supervisor privileges." + vbCrLf + "Nothing was done.", _
                           "Message from WinHelper", _
                           MessageBoxButtons.OK, _
                           MessageBoxIcon.Information)
    End Sub

    Private Function CallUserPermission() As Boolean
        If MessageBox.Show("To change this property the administrator privileges are required." + vbCrLf + vbCrLf + _
                           "Restart with administrator privileges?", _
                           "Message from WinHelper", _
                           MessageBoxButtons.YesNo, _
                           MessageBoxIcon.Question, _
                           MessageBoxDefaultButton.Button1, _
                           CType(&H40000, MessageBoxOptions)) = DialogResult.Yes Then
            Save_INI()
            'Form1.HideTrayIcon()
            RestartAsAdministrator()
            Return True
        Else
            Return False
        End If
    End Function

    Private Function IsAdministrator() As Boolean
        Return New Security.Principal.WindowsPrincipal( _
                   Security.Principal.WindowsIdentity.GetCurrent).IsInRole( _
                   Security.Principal.WindowsBuiltInRole.Administrator)
    End Function

    Friend RestartArguments As String = ""

    Private Sub RestartAsAdministrator()
        Dim exeName As String = System.Diagnostics.Process.GetCurrentProcess.MainModule.FileName
        Dim startInfo As ProcessStartInfo = New ProcessStartInfo(exeName)
        startInfo.Verb = "runas"
        startInfo.Arguments = RestartArguments
        Try
            System.Diagnostics.Process.Start(startInfo)
        Catch
            Message_NoSupervisor()
        End Try
        End
    End Sub

End Module
