' ================================================================================================
' - ENGLISH - ArduinoIDE Change Colors
' ================================================================================================
'  This script corrects the file: Arduino\lib\theme\theme.txt
'  The compilation report olors are changed,
'  from an impossible dark-red on black, to normal and easely redable colors.
' ------------------------------------------------------------------------------------------------
'  1) Copy the "ArduinoIDE_ChangeColors.exe" file near to the "arduino.exe" file
'  2) Start (AS ADMINISTRATOR) the "ArduinoIDE_ChangeColors.exe" file
'  3) Restart ArduinoIDE
' ================================================================================================

' ================================================================================================
' - ITALIANO - ArduinoIDE Change Colors
' ================================================================================================
'  Questo script corregge il file: Arduino\lib\theme\theme.txt
'  I colori del report della compilazione vengono modificati,
'  da un assurdo rosso scuro su nero, a colori normali e facilmente leggibili.
' ------------------------------------------------------------------------------------------------
'  1) Copiare il file "ArduinoIDE_ChangeColors.exe" vicino al file "arduino.exe"
'  2) Lanciare (COME AMMINISTRATORE) il file "ArduinoIDE_ChangeColors.exe" 
'  3) Riavviare ArduinoIDE
' ================================================================================================

Dim ProgramName As String = "ArduinoIDE Color Changer"

' ================================================================================================
' This function opens the file: <arduino> \ Lib \ theme.theme.txt 
' and changes the colors in the section "GUI - CONSOLE".   
' ================================================================================================
'# GUI - CONSOLE  (ORIGINAL COLORS)
'console.font = Monospaced,plain,11
'console.font.macosx = Monaco,plain,10
'console.color = #000000
'console.output.color = #eeeeee
'console.Error.color = #E34C00
' ------------------------------------------------------------------------------------------------
'# GUI - CONSOLE  (CHANGED COLORS)
'console.font = Monospaced,plain,11
'console.font.macosx = Monaco,plain,10
'console.color = #FFFFFF
'console.output.color = #000000
'console.Error.color = #600000
' ================================================================================================

Sub OpenAndConvertTheFile
	' -------------------------------------------- set the base path
	Dim path As String 
	path = ".\lib\theme"
	' -------------------------------------------- create file path and test it
	Dim file1 As String = path + "\theme.txt"
	Dim file2 As String = path + "\theme_backup.txt"
	If io.file.exists(file1) Then 
		Label1.Text = "The path is valid: " + VbCrLf + file1
	Else
		Label1.Text = "Path not found: " + VbCrLf + file1
		Label1.Text += VbCrLf + VbCrLf + VbCrLf
		Label1.Text += "Please copy this file near to the ""arduino.exe"" file"+ VbCrLf
		Label1.Text += "then start it with the right mouse button and ""Run as administrator"""
		Return
	End If
	' -------------------------------------------- open the file	
	Dim sr As IO.StreamReader  = New IO.StreamReader(file1)
	Dim s As String = sr.ReadToEnd
	sr.close
	' ------------------------------------------------ test the string
	If s.contains(VbLf + "console.color = #000000") Then
		'
		' -------------------------------------------- make a backup copy
		IO.File.Copy(file1, file2, True)
		Label1.Text += VbCrLf + VbCrLf
		Label1.Text += "The file has been copied for backup as:" 
		Label1.Text += VbCrLf + file2
		' -------------------------------------------- replace the string
		s = s.replace(VbLf + "console.color = #000000", _
					VbLf + "console.color = #FFFFFF")      ' FFFFD0
					
		s = s.replace(VbLf + "console.output.color = #eeeeee", _
					VbLf + "console.output.color = #000000")
					
		s = s.replace(VbLf + "console.error.color = #E34C00", _
					VbLf + "console.error.color = #600000")
		' -------------------------------------------- 
		Dim sw As IO.StreamWriter = New IO.StreamWriter(file1)
		sw.write(s)
		sw.close
		' --------------------------------------------------------- final message
		Label1.Text += VbCrLf + VbCrLf
		Label1.Text += "OK: Arduino IDE colors are changed."
	Else
		Label1.Text += VbCrLf + VbCrLf + VbCrLf
		Label1.Text += "The line: ""console.color = #000000"" has not been found in the file." + VbCrLf
		Label1.Text += VbCrLf
		Label1.Text += "Probably the file has been already corrected."
	End If
End Sub


' ---------------------------------------------------------------------- 
'  User Interface Components
' ---------------------------------------------------------------------- 
WithEvents Form1 As Form
Dim Label1 As Label = New Label

Sub Main(ByVal s() As String)
	If Form1 IsNot Nothing Then Return
	Form1 = New Form
	InitializeComponents
	OpenAndConvertTheFile
	While Form1.Visible
		Application.DoEvents
		Threading.Thread.Sleep(10)
	End While
End Sub

Sub InitializeComponents()
	Application.EnableVisualStyles
	form1.SuspendLayout
	' ------------------------------------------------------------------ Form
	Form1.Text = "Theremino Script - " & ProgramName
	Form1.FormBorderStyle = FormBorderStyle.Sizable
	Form1.ClientSize = New System.Drawing.Size(1020, 160)
	Form1.MinimumSize = Form1.Size
	Form1.StartPosition = FormStartPosition.CenterScreen
	' ------------------------------------------------------------------ Label
	Label1.Location = New Point(4, 4)
	label1.Anchor = AnchorStyles.Bottom Or AnchorStyles.top Or AnchorStyles.left Or AnchorStyles.Right
	Label1.Width = Form1.ClientSize.Width - Label1.Left - 4
	Label1.Height = Form1.ClientSize.Height - Label1.Top - 4
	Label1.BackColor = Color.AliceBlue
	Label1.ForeColor = Color.Black
	Label1.Font = New Font("Tahoma", 11, FontStyle.Regular)
	Label1.TextAlign = ContentAlignment.Topleft
	Form1.Controls.Add(Label1)
	' ------------------------------------------------------------------ 
	Form1.ResumeLayout
	Form1.PerformLayout()
	Form1.show
End Sub

